def proc specific_init
  epson_chr_tables
end def specifi_init
:
def fn parse_line$(line$,gstate,line_width)
rem This parses a line to extract printer directives
rem and "prints" it to the Prowess device
rem the printer directives handled up to now are
rem <i>, <b>, <u>, <h> and <l> (and the corresponding / ones)
rem Also, things like Quill don't send a line feed after a form feed, so we
rem must weed out potential form feeds.
rem Thus, this funtcion returns "" if not new page, else the string
rem to print after the FF
LOCal a$,t%,lp%,undl_start(80),undl_stop(80),x_pos,jump%,front$,end$,lp2%
local tagtype%
  if line$="":return "" 		: rem nothing to do
  a$=line$				: rem keep this local
  end$=""				: rem nothing to return yet
  t%=chr$(12) instr a$			: rem any form feed in line?
  if t%
					: rem yes, now cater for special cases: just FF, FF at end of line, FF not at end of line etc
    if t%= len(a$)
      end$=chr$(12)			: rem form feed at end of line
      if len(a$)<>1
	a$=a$(1 to t%-1)		: rem what is there?
	end$=chr$(12)
      else
	return end$
      endif
    else
      if t%=1
	end$=a$(t%+1 to):a$=""
      else
	end$=a$(t%+1 to)
	a$=a$(1 to t%-1)
      endif
    endif
  else
    end$=""				: rem nothing to return
  endif
  t%=len(a$)				: rem length of line with stripped of form feed, if any
  if not t%:ret end$			: rem nothing left
  x_pos=left_margin			: rem this is where we start printing
  front$=""
  if underline_on%:undl_start(1)=left_margin : rem if underlining
  for lp%=1 to t%
    IF a$(lp%)=chr$(27)
      jump%=0				: rem no need to jump over tag yet
      tagtype%= extract_tag%(a$,lp%)	: rem check : is it a valid tag, and if yes, what tag
      lp%=lp%+jump%			: rem jump% is set in extract_tag%
      select on tagtype%
	=0				: rem just the ESC char - ignore
	=1,5,7,9			: rem bold/italics/high/low on
	  if front$<>""
	    PFShow Gstate,front$	: rem first, print anything up to now
	    if debug%:print#debug%,front$;
	  endif
	  front$=""			: rem no front any more
	  select_font tagtype%		: rem do what is necessary for fonts
	  pfmoveto gstate,x_pos,ypos
	=2,6,8,10			: rem bold, italics off
	  if front$<>""
	    PFShow Gstate,front$
	    if debug%:print#debug%,front$;
	  endif
	  front$=""
	  select_font tagtype%
	  pfmoveto gstate,x_pos,ypos
	=3				: rem underline on
	  if not underline_on%
	    underline_on%=1		: rem sjow we're underlining now
	    for lp2%=1 to 80
	      if undl_start(lp2%)=0
		undl_start(lp2%)=x_pos	: rem search for empty underlining pos
	      endif
	    end for lp2%
	  endif
       =4				: rem underline off
	  if underline_on%
	    underline_on%=0
	    for lp2%=1 to 80
	      if undl_stop(lp2%)=0
		undl_stop(lp2%)=x_pos
	      endif
	    end for lp2%
	  endif
      end select
    else
      front$=front$&epson_translate$(a$(lp%))
      x_pos=x_pos+x_inc 		: rem x position for next char to print
    END IF
  END for lp%
  IF front$<>"":  PFShow Gstate,front$	: rem print this line (what's left of it)
  if debug%:print#debug%,front$
  underline  undl_start,undl_stop	: rem do any underlining now
  ret end$
END DEFine parse_line$
:
def proc underline (undl_start,undl_stop)
rem underline (parts of) a line
rem undl_start and undl_stop are local arrays(80) from parse_line$
local lp%
  for lp%=1 to 80
    if undl_start(lp%)<>0
      if undl_stop(lp%)<>0
	 trace undl_start(lp%),undl_stop(lp%)-undl_start(lp%)
      else
	 trace undl_start(lp%),line_width-undl_start(lp%)
      end if
    end if
  end for lp%
end def underline
:
DEFine PROCedure trace(start_pos,x_length)
rem draw a line
  PFMoveTo Gstate,start_pos,ypos+1
  PFLineR Gstate,x_length,0
  PFPathClose Gstate
  PFPathDraw Gstate
END DEFine trace
:
def fn extract_tag% (word$,start%)
rem this extracts a tag from word$, starting at start% (word$(tag%) should be = "<")
rem this retuns 0 if no end tag was found
rem else this returns	1 - bold on
rem			2 - bold off
rem			3 - underline on
rem			4 - underline off
rem			5 - high on
rem			6 - high off
rem			7 - low on
rem			8 - low off
rem			9 - italics on
rem			10- italics off
rem
rem this MUST also set the variable jump% to the number of chars that should
rem be jumped over in the line, to eliminate the rest of the the tag.
rem (jump% is set to 0 on entry by caller)
LOCal lp%,count%,off$,b$
  IF start%=LEN(word$):RETurn 0
  count%=start%+1:rem Check character after ESC
  off$=word$(count%)
  SELect ON off$
    ='@'
      jump%=1				: rem ESC,@
      RETurn 0				: rem Do nothing - initialise printer
    ='R'
      jump%=2 :rem ESC R,n
      IF LEN (word$)>count%:chr_table=CODE(word$(count%+1))=0
      RETurn 0				: rem Change character set for translates
    ='C'
      IF LEN (word$)>count%:IF CODE(word$(count%+1))=0
	jump=3				: rem ESC C,0,n - set page length in inches
      ELSE
	jump=2				: rem ESC C,n - set page length in lines
      END IF :END IF
      RETurn 0
    ='E'
      jump%=1
      RETurn 1				: rem ESC,E: Bold ON
    ='F'
      jump%=1
      RETurn 2				: rem ESC,E: Bold OFF
    ='-'
      IF LEN (word$)>count%
	IF word$(count%+1)='1'
	  jump%=2			: rem ESC - 1:Underline ON
	  RETurn 3
	ELSE
	  IF word$(count%+1)='0'
	    jump%=2			: rem ESC - 0:underline OFF
	    RETurn 4
	  END IF
	else
	 return 0			: rem huh?
	END IF
      else
	return 0
      END IF
    ='S'
      IF LEN (word$)>count%
	IF word$(count%+1)='1'
	  jump%=2			: rem ESC S 0:Superscript ON
	  RETurn 5
	ELSE
	  IF word$(count%+1)='0'
	    jump%=2			: rem ESC S 1:Subscript ON
	    RETurn 7
	  END IF
	else
	  return 0
	END IF
      else
	return 0
      END IF
    ='T'
	 jump%=1			: rem ESC T : Cancel sub/superscript
	 if exponent_on%:return 6
	 if subindic_on%:return 8
	 RETurn 0
    = REMAINDER : RETurn 0		: rem Not yet implemented Epson control code
  END SELect
  RETurn 0
END DEFine extract_tag%
:
