*************************************************************************
*
*  PFF device, a simple device to con older programs that can't
*  print to a file
*
*
*  v. 0.00	2004 Nov 26 14:21:04
*
*  S*basic support routine PFF_USE
*
*
*  (c) W. Lenerz 2004
***********************************************************************


	section basic
	xdef	pff_use
	xdef	fnd_dev

	xref	open

	include dev1_asm_pff_includes_asm
	include dev8_keys_qlv
	include dev8_keys_sys
	include dev8_keys_err
	include dev8_keys_qdos_sms

;------------------------------------------------
; PFF_USE 'string'	must be a three chars string


pu_errbp   moveq   #-$0f,d0			   ; err_bp
pu_out	 rts
	
pff_use
	move.w	sb.gtstr,a2
	jsr	(a2)			; get string parameter
	bne.s	pu_out			; ooops
	subq.w	#1,d3			; only one
	bne.s	pu_errbp		; ooops
	move.w	(a6,a1.l),d1		; length into d1
	cmpi.w	#3,d1			; must be 3 chars
	bne.s	pu_errbp		; ooops
	move.l	a1,a4			; a4 points to this usage string now
	move.l	a1,$58(a6)		; this is the maths pointer (!)
	bsr.s	fnd_dev 		; find my device driver
	bne.s	pu_out
	lea	usage+2(a0),a2		; point to usage string
	move.l	2(a6,a4.l),d0
	andi.l	#$dfdfdfdf,d0		; case
	move.l	d0,(a2) 		; copy new one accross
	moveq	#0,d0
	rts

fnd_dev 				; find our dd defn blk
	move.w	sr,d0			; keep status reg
	trap	#0			; go into supervisor mode to avoid new links
	move.w	d0,-(a7)		; sr onto stack
	moveq	#sms.info,d0		; mt_inf
	trap	#1			; get sysvays
	move.l	sys_iodl(a0),a0 	; non filing system io driver list
	lea	open,a1
pff_lp	cmp.l	8(a0),a1		; is this our driver ?
	beq.s	drv_fnd 		; yes
	movea.l (a0),a0 		; no, so go on to next driver
	move.l	a0,d1			; but can we?
	bne.s	pff_lp			;   ... yes
	moveq	#err.itnf,d0		; err_nf if end of list and not found
	bra.s	pff_usr
drv_fnd 				; here we found our driver
	lea	-$18(a0),a0		; point to presumed start dd defn blk
	moveq	#0,d0
pff_usr move.w	(a7)+,sr		; get back into normal mode
	tst.l	d0			;
	rts				; return with error

	
	end
