******************************************************************
*
*
*	prt device associated code
*
*	this tries to execute a file , called form intermediary job
*	simplified code, push pipename on stack
*
*	v. 0.01 2004 Dec 04 09:26:14  A0 points to pipe name on entry
*
*	(c) W. Lenerz 2004
*
******************************************************************

	section job

	include dev8_keys_qdos_sms
	include dev8_keys_err
	include dev8_keys_qdos_ioa
	include dev8_keys_qdos_io
	include dev1_asm_pff_includes_asm


	xdef	fileex

	xref	pipename		; name of pipe to open
	xref	fname			; name of file to open
	xref	actv_jb

stacka0 equ	4

fileex
	lea	fname,a0		; name fo file to execute
	moveq	#ioa.kshr,d3		; file must already exist
	moveq	#ioa.open,d0		; open channel
	moveq	#-1,d1			; for myself
	trap	#2			; now
	tst.l	d0
	bne.s	out			; ooops
	move.l	a0,d7			; keep channel ID
	sub.l	#70,a7
	move.l	a7,a1			; file info will go here
	moveq	#64,d2			; length of gile header
	moveq	#-1,d3
	moveq	#iof.rhdr,d0		; read file header
	trap	#3			; now
	move.l	a7,a1
	add.l	#70,a7
	tst.l	d0
	bne.s	close			; ooops, couldn't
	moveq	#err.ipar,d0		; preset error
	cmp.b	#1,5(a1)		; is file executable?
	bne.s	close			; no, so close & leave
	move.l	(a1),d6 		; file length
	move.l	6(a1),d5		; data space

; the file is found and executable

	move.l	stacka0(a7),a0		; point to pipe name
	clr.l	d4
	move.w	(a0),d4 		; length of this name
	move.l	d5,d3			; data space
	add.l	d4,d3
	addq.l	#7,d3			; length word for name + channel ID
	bclr	#0,d3			; make even
	move.l	d6,d2			; code space
	sub.l	a1,a1			; start at copy of header, please
	moveq	#0,d1			; is owned by job 0
	moveq	#sms.crjb,d0
	trap	#1			; create job now (d1 = job id)
	tst.l	d0			; ok?
	bne.s	close			; no, close channel & return to caller
; as of here, A0 = job
	move.l	a0,a4			; keep pointer to job area
	move.l	a0,a1
	move.l	d7,a0			; channel ID
	move.l	d6,d2			; length of file
	moveq	#-1,d3
	moveq	#iof.load,d0
	move.l	d1,-(a7)
	trap	#3			; load file into mem now
	move.l	(a7)+,d1
	tst.l	d0
	bne.s	close			; ooops
	bsr.s	close			; close file now
	move.l	stacka0(a7),d7		; name of pipe
	bra	actv_jb

close	move.l	d7,a0			; close file
	move.l	d0,-(a7)
	moveq	#2,d0
	trap	#2
	move.l	(a7)+,d0
out	rts
	end
