******************************************************************
*
*
*	prt device associated code
*
*	this executes an executable thing
*	simplified code, push pipename on stack
*
*	copyright (c) W.Lenerz 2004
*
*	v. 1.00
******************************************************************

	section job

	include dev8_keys_qdos_sms
	include dev8_keys_err
	include dev8_keys_chn
	include dev8_keys_thg
	include dev1_asm_pff_includes_asm


	xdef	thex
	xdef	actv_jb
	xref	thname			; name of thing to be executed
	xref	use_thg 		; use thing routine
	xref	pipename		; name of pipe to open
	xref	do_vect 		; do thing vector
	xref	free_thg

stacka0 equ	4			; a0 on stack
stacka1 equ	stacka0+4		; a1 on stack

thex
	move.l	a0,d7			; keep pipename
	lea	thname,a0		; thing name
	bsr	use_thg 		; try to use this thing (A1 will be thg)
	bne	out			; ooops, couldn't
	moveq	#err.ipar,d0		; preset error
	cmp.l	#tht.exec,thh_type(a1)	; is thing executable?
	bne	rel_thg 		; no, so free thing & leave
	move.l	a1,a5			; keep pointer to thing

; the thing is found and executable

execth
	move.l	d7,a0			; point to pipe name
	clr.l	d4
	move.w	(a0),d4 		; length of this name
	move.l	thh_hdrl(a1),d6 	; thing header length ("code" space)
	move.l	d6,d2
	move.l	thh_data(a1),d5 	; thing data & code space
	move.l	d5,d3
	add.l	d4,d3
	add.l	#11,d3			; length word for name + channel ID + job ID
	bclr	#0,d3			; make even
	move.l	thh_strt(a1),d0 	; where do we start ?
	beq.s	at_head 		; at header
	add.l	d0,a1			; point to code now
	bra.s	do_it
at_head sub.l	a1,a1			; start at copy of header, please
do_it	moveq	#0,d1			; is owned by job 0
	moveq	#sms.crjb,d0
	trap	#1			; create job now (d1 = job id)
	tst.l	d0			; ok?
	bne.s	rel_thg 		; no, free thing & return to caller

	move.l	a5,a1			; a1=  this thing
	move.l	a0,a4			: a4 points to start of code for this job
	move.l	thh_hdrl(a1),d0 	; thing name length
	add.l	thh_hdrs(a1),a1 	; a1 now points to header
thexlp1 move.b	(a1)+,(a0)+
	subq.l	#1,d0
	bge.s	thexlp1 		; transfer header
	move.l	d1,-(a7)		; job id of new job
	lea	thname,a0
	bsr	free_thg		; free this thing now
	move.l	(a7),d1
	moveq	#-1,d3
	moveq	#sms.uthg,d0		; new job must use thing to avoid thg
	bsr	do_vect 		; being removed without job being removed)
	move.l	(a7)+,d1		; get job ID back
actv_jb move.l	a4,a2			; keep
	add.l	d6,a2			; a2 points to end of stack
	add.l	d5,a2			; point to stack now
	move.l	a2,-12(a4)		; make sure this is indeed job stack
	clr.w	(a2)+			; no channels, no command string yet
do_str	move.l	d7,a0			; name of channel opened
	move.w	(a0)+,d0
	move.w	d0,d2
	addq.w	#4,d2
	move.w	d2,(a2)+		; fill in length
	bra.s	do_cplp
copylp	move.b	(a0)+,(a2)+		; copy pipe name
do_cplp dbf	d0,copylp
	move.l	stacka1(a7),a3		; CDB
	lea	chn_ownr(a3),a3
	move.b	(a3)+,(a2)+
	move.b	(a3)+,(a2)+
	move.b	(a3)+,(a2)+
	move.b	(a3)+,(a2)+		; add job ID !!!
	moveq	#32,d2			; priority
	moveq	#0,d3
nc_com	moveq	#sms.acjb,d0
	trap	#1			; activate job
out	rts
rel_thg move.l	d0,-(sp)
	lea	thname,a0
	bsr	free_thg
	move.l	(sp)+,d0
	rts

	end
