*************************************************************************
*
*  PFF device, a simple device to con older programs that can't
*  print to a file
*  v. 1.00 2005 Jan 19 added version
*  v. 0.02 2004 Dec 04 09:44:26 check for older system, change pipe name
*  v. 0.01 2004 Nov 28 10:10:43 initial version
*
*  this is the init routine - link in basic keywords & device driver
*
*  (c) W. Lenerz 2004
*
***********************************************************************


	section device
	xdef	start
	xdef	jobname
	xdef	setupjb
	xref	pffname 		; name in iou.dnam format
	xdef	pipename
	xdef	qdospipe
	xref	procdef 		; basic procedures
	xref	open			; open routine
	xref	close			; close routine
	xref	iorout			; io routine
	xref	jobcode 		; code for intermediary job
	xref	psize			; configured size of pipe
	xref.l	version

	include dev1_asm_pff_includes_asm ; my own includes
	include dev8_keys_qlv		; QL vector keys
	include DEV8_keys_qdos_sms	; trap 1 keys
	include dev8_keys_jcbq		; job control block
	include dev8_keys_sys

start	bra.s	start2
	dc.w	'PFF device driver v.'
	dc.l	version

start2	lea	procdef,a1
	move.w	sb.inipr,a2		; link in basic procs
	jsr	(a2)			; now
	tst.l	d0
	bne	int_out 		; ooops!
dd_start
	moveq	#sms.info,d0
	trap	#1			; get info on system we're running on
	tst.l	d0
	bne	int_out 		; ooops
	move.l	sys_idnt(a0),d7 	; system identifier

	moveq	#sms.achp,d0		; mt_alchp
	move.l	#enddd,d1		; bytes need for dd defn block
	moveq	#0,d2			; owner is job 0
	trap	#1			; get bytes for device driver definition block
	tst.l	d0
	bne	int_out 		; couldn't!
	cmp.l	#'SMSQ',d7		; are we smsq?
	bne.s	no_smsq 		; no
	st	ident(a0)		; what system we're running on
no_smsq lea	$1c(a0),a3		; io routine goes here
	lea	iorout,a2
	move.l	a2,(a3)+		; io routine
	lea	open,a2
	move.l	a2,(a3)+		; open routine
	lea	close,a2
	move.l	a2,(a3)+		; close routine
	move.w	#3,(a3)+
	move.l	#'PFF ',(a3)+		; name
					; (there are no scheduler etc routines)
	lea	qdosp(a0),a3
	move.w	#8,(a3)+
	move.l	#'pipe',(a3)+		; kludge for qdos - fake pipename

	lea	usage(a0),a3		; usage name
	lea	pffname+2,a2		; this is the true name
	move.w	#3,(a3)+		; name length
	move.l	(a2)+,(a3)+		; name itself: usage = true name for now
	lea	device(a0),a3		; output device to open
	lea	pipename,a2		; point to SMSQ pipe
	cmp.l	#'SMSQ',d7
	beq.s	smsq
	lea	qdospipe,a2		; we're not SMSQ, use Qdos pipe
smsq	move.l	a2,a1			; keep pointer
	move.w	(a2)+,d0
	move.w	d0,d2			; keep length
	lea	psize,a4		: size of pipe
	move.w	(a4)+,d3		; lenght of this
	bgt.s	okpipe			; something is wrong, so use
	lea	defplen,a4		; the default length
	move.w	(a4)+,d3
okpipe	add.w	d3,d2			; combined length
	addq.w	#1,d2			; plus "_"
	move.w	d2,(a3)+		; set total name length
	bra.s	do_cplp 		; now copy name
cpy_lp	move.b	(a2)+,(a3)+
do_cplp dbf	d0,cpy_lp
	move.b	#'_',(a3)+		; separator
	subq.w	#1,d3
cpy_lp2 move.b	(A4)+,(A3)+
	dbf	d3,cpy_lp2

*  now link in driver
	move.l	a0,-(a7)		; keep dd defn block
	lea	$18(a0),a0		; jump over header
	moveq	#sms.liod,d0		; link in driver
	trap	#1			; now
	move.l	(a7)+,a5		; keep dd defn block in a safe place
	tst.l	d0			; link went OK?
	bne.s	int_out 		;   ... no
* now setup intermediary job
setupjb sub.l	a1,a1			; start of job code
	clr.l	d1			; owner = job 0
	move.l	#100,d2 		; code space required
	move.l	#800,d3 		; data (stack) space
	moveq	#sms.crjb,d0
	trap	#1			; create this job
	tst.l	d0
	bne.s	int_out 		; ooops
	move.l	a0,d0
	sub.l	#jcb_end,d0		; point to start of job control block
	move.l	d0,jctblk(a5)		; keep this pointer
	move.l	d1,jobid(a5)		; and the job ID

	lea	jobname,a1		; name of this job
	lea	jobcode,a2		; real start of this job
	move.w	#$4ef9,(a0)+
	move.l	a2,(a0)+		; make jump to our addresss
	move.w	#$4afb,(a0)+		; standard job marker
	move.w	(a1)+,d2		; job name length
	move.w	d2,(a0)+		; copied across
	subq.w	#1,d2			; I know this is not a 0 length name
onlp1	move.b	(a1)+,(a0)+
	dbf	d2,onlp1
	moveq	#0,d3			; don't wait for completion
	moveq	#0,d2			; priority : 0
	moveq	#sms.acjb,d0
	trap	#1			; start that job
	tst.l	d0
int_out rts				; and return with error therefrom

pipename
	dc.w	pipename2-*-2
	dc.b	'pipe_PFF0000'
pipename2
endit	ds.l	20			; leave some more space for longer name

jobname dc.w	jname-*-2		; name for intermediary job
	dc.b	'PFF Intermediary Job'
jname

qdospipe
	dc.w	qp2-*-2
	dc.b	'pipe'
qp2
defplen dc.w	5,'10000'
	end
