*****************
*
*  pff device : intermediary job
*
*
* this checks up the intermediary job
*
* v. 0.012004 Dec 10 19:11:11	sanity check introduced
* v. 0.00
*
* (c) W. Lenerz
*
******************************

	section device

	xdef	chk_job 		; check the job
	xdef	jobcode 		; code of intermediary

	xref	thex			; execute thing
	xref	fileex			; execute file

	include dev8_keys_jcbq
	include dev8_keys_err
	include dev8_keys_sys
	include dev8_keys_chn
	include dev8_keys_qdos_sms
	include dev1_asm_pff_includes_asm


; check this job - it must exist & be of priority 0
; There is no chance of the
; job disappearing after the check since we're in supervisor mode

infregs reg	d1-d4/a0/a1
chk_job
	movem.l infregs,-(a7)
	clr.l	d2
	move.l	jobid(a2),d1		; its job ID
	moveq	#sms.injb,d0
	move.l	a2,d4
	trap	#1			; get info on this job
	tst.l	d0			; is job OK?
	bne.s	rj_out			;  ...no
	move.l	d4,a2
	move.l	jctblk(a2),a0		; point to job control block
	move.b	jcb_pinc(a0),d0 	; priority increase should be 0!!!
rj_out	movem.l (sp)+,infregs
	rts


; this is the code for the job released by the PFF device


	section job

	xdef	jobcode
; the job is set up in such a way that A0 will point to the name of the
; pipe
; ATTENTION: each time the job is awoken by the PFF channel open routine,
; its register A0 will have changed, pointing to the new pipename!!!!
; and A1 set to chen defn block
jobcode 				; first a sanity check
	cmp.l	#waterm1,d1		; check that job was woken by the...
	bne.s	snooze			; ...pff and not the user...
	cmp.l	#waterm2,d2
	bne.s	snooze
	cmp.l	#waterm3,d3
	bne.s	snooze
	movem.l a0/a1,-(a7)		; keep pointers to pipe name & CDB
	cmp.l	#'_PFF',6(a0)		; are we in smsqe?
	beq.s	exeth			; yes, no need to search for channel ID
	bsr.s	srchid			; qdos : find channel ID
	bne.s	stopme			; couldn't find it!!!!
	movem.l (a7),a0/a1		; point to name
	move.l	d1,6(a0)		; add channel ID after it (!)
exeth	bsr	thex			; try to execute thing
	tst.l	d0			; OK?
	beq.s	stopme			;  ... yes,
	movem.l (a7),a0/a1
	bsr	fileex			; ... no, try to execute file
stopme	addq.l	#8,a7			; no more need for stored A0 & A1
snooze	moveq	#-1,d1
	moveq	#0,d2			; priority will be 0 - deactivate
	moveq	#0,d3
	moveq	#sms.spjb,d0
	trap	#1			; deactivate me!
	bra.s	jobcode

; QDOS : search for my channel ID, so that I can pass it after the pipename
; A0 points to the device name (in the dd defn block),
; but at -4(a0) is the channel defn block for the PFF channel opened

srchid	move.w	sr,d0
	trap	#0
	move.w	d0,-(a7)		; go super
	move.l	a0,a1			; keep pointer
	moveq	#sms.info,d0
	trap	#1			; get sysvars into a0
	move.w	chn_tag(a1),d1		; channel tag
	swap	d1
	move.w	#0,d1			; first channel number
	move.l	sys_chtb(a0),a2 	; channel table base
	move.l	sys_chtt(a0),a3 	; channel table top
	move.l	-4(a1),d0		; my channel denf block
fndlp	cmp.l	(a2)+,d0		; is it this channel?
	beq.s	chfnd			; yes
	addq.w	#1,d1			; new number
	cmp.l	a3,a2
	ble.s	fndlp
	moveq	#err.itnf,d0		; can't find this channel in table!!!!
	bra.s	out
chfnd	moveq	#0,d0
out	move.w	(a7)+,sr
	tst.l	d0
	rts


	end
