     
*----------------------------------------------------------------------
*	basic support routines for PFF device
*
*	chan%=OPIPE("pipexxxx")
*	tries to open pipe where x is pipe's channel ID
*
* returns sbasic channel number if ok, negative error code if not
* based on (F)TOPEN
*
* v. 1.00	2004 Dec 04
*
* c) W. Lenerz 2004
*
*------------------------------------------------------------------------
	
	section basic

	xdef	pff_opipe
	include dev8_keys_qlv
	include dev8_keys_err
	include dev8_keys_sbasic
	include dev8_keys_qdos_ioa

; first find an entry in the sbasic channel table

pff_opipe
	moveq	#ch.len,d3		; length of sbasic channel table entry
	moveq	#$3,d7			; lowest sb channel possible
	moveq	#3*ch.len,d5
	add.l	sb_chanb(a6),d5 	; point to bv_chbas
loop3	cmp.l	sb_chanp(a6),d5 	; did we exceed table?
	bge.s	orng			; yes, error
	tst.w	$2(a6,d5.l)		; is channel entry empty?
	blt.s	is_empty		; yes->...
	addq.w	#1,d7			; no, new possible channel number
	add.l	d3,d5			; point to new entry
	bra.s	loop3			; and try again
is_empty
	add.l	d3,d5			; point to end of this channel table entry
clear	subq.l	#4,d5			; point earlier word
	clr.l	(a6,d5.l)		; clear this
	subq.l	#4,d3			; and do this until entire entry cleared
	bgt.s	clear
	not.l	(a6,d5.l)		; set to -1 - show it is empty
	move.w	#80,$22(a6,d5.l)	; width of page is preset: 80 chars

; as of here: d5= points to entry
; d7 = channel number

; now get string
	move.l	a1,a4
	move.w	sb.gtstr,a2
	jsr	(a2)			; get one string
	tst.l	d0			; ok?
	bne.s	ret_er			; no->...
	cmp.w	#8,(a6,a1.l)		; length is 8?
	bne.s	err_bp			; no
	move.l	2(a6,a1.l),d0		; should be 'pipe'
	andi.l	#$dfdfdfdf,d0
	cmp.l	#'PIPE',d0
	bne.s	err_bp			; but it isn't
	move.l	6(a6,a1.l),d3		; pipe's channel ID
	move.l	a4,$58(a6)		; reset maths stack
	lea	pname,a0
	moveq	#-1,d1			; for myself
	moveq	#1,d0			; open channel
	trap	#2
	tst.l	d0			; ok?
	bne.s	ret_er			; no->...
	move.l	a0,(a6,d5.l)		; set channel id in sbasic channel table
	move.w	d7,d4			; channel number
	bra.s	rt_int			; return it
ret_er	move.l	d0,d4			; return error
	bra.s	rt_int
orng	moveq	#err.orng,d4		; return out of range
	bra.s	rt_int
err_bp	moveq	#err.ipar,d4

; rt_int:  returns an integer to basic
; on entry, d4 contains integer to send
rt_int	moveq	#2,d1
	move.l	$58(a6),a1
	move.w	$11a,a2
	jsr	(a2)		; get space on maths stack
	move.l	$58(a6),a1
	subq.l	#2,a1
	move.l	a1,$58(a6)
	move.w	d4,(a6,a1.l)
	moveq	#3,d4
	moveq	#0,d0
	rts


pname	dc.w	4,'pipe'

	end
